var React = require("react");
var PureRenderMixin = require("react/lib/ReactComponentWithPureRenderMixin");
var cx = require("classnames");
var DraggableMixin = require("./DraggableMixin");


var Map = React.createClass({displayName: "Map",

  mixins : [DraggableMixin, PureRenderMixin],

  propTypes: {
    x : React.PropTypes.number.isRequired,
    y : React.PropTypes.number.isRequired,
    backgroundColor : React.PropTypes.string,
    className : React.PropTypes.string
  },

  getDefaultProps: function() {
    return {
      x : 0,
      y : 0,
      backgroundColor : "transparent"
    };
  },

  updatePosition : function(clientX, clientY, isFinished) {
    var rect = this.getBoundingRect();

    var x = (clientX - rect.left) / rect.width;
    var y = (rect.bottom - clientY) / rect.height;

    this.props.onChange(
      this.getScaledValue(x),
      this.getScaledValue(y),
      isFinished
    );
  },

  render: function () {
    var classes = cx("map", this.props.className, { active : this.state.active });

    return (
      React.createElement("div", {
        className: classes, 
        onMouseDown: this.startUpdates, 
        onTouchStart: this.startUpdates
      }, 
        React.createElement("div", {className: "background", style: {
          backgroundColor: this.props.backgroundColor
        }}), 
        React.createElement("div", {className: "pointer", style: {
          left: this.getPercentageValue(this.props.x),
          bottom: this.getPercentageValue(this.props.y)
        }})
      )
    );
  }

});

module.exports = Map;
